// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/openshift/api/operator/v1alpha1"
	scheme "github.com/openshift/client-go/operator/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ImageContentSourcePoliciesGetter has a method to return a ImageContentSourcePolicyInterface.
// A group's client should implement this interface.
type ImageContentSourcePoliciesGetter interface {
	ImageContentSourcePolicies() ImageContentSourcePolicyInterface
}

// ImageContentSourcePolicyInterface has methods to work with ImageContentSourcePolicy resources.
type ImageContentSourcePolicyInterface interface {
	Create(ctx context.Context, imageContentSourcePolicy *v1alpha1.ImageContentSourcePolicy, opts v1.CreateOptions) (*v1alpha1.ImageContentSourcePolicy, error)
	Update(ctx context.Context, imageContentSourcePolicy *v1alpha1.ImageContentSourcePolicy, opts v1.UpdateOptions) (*v1alpha1.ImageContentSourcePolicy, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ImageContentSourcePolicy, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ImageContentSourcePolicyList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ImageContentSourcePolicy, err error)
	ImageContentSourcePolicyExpansion
}

// imageContentSourcePolicies implements ImageContentSourcePolicyInterface
type imageContentSourcePolicies struct {
	client rest.Interface
}

// newImageContentSourcePolicies returns a ImageContentSourcePolicies
func newImageContentSourcePolicies(c *OperatorV1alpha1Client) *imageContentSourcePolicies {
	return &imageContentSourcePolicies{
		client: c.RESTClient(),
	}
}

// Get takes name of the imageContentSourcePolicy, and returns the corresponding imageContentSourcePolicy object, and an error if there is any.
func (c *imageContentSourcePolicies) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ImageContentSourcePolicy, err error) {
	result = &v1alpha1.ImageContentSourcePolicy{}
	err = c.client.Get().
		Resource("imagecontentsourcepolicies").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ImageContentSourcePolicies that match those selectors.
func (c *imageContentSourcePolicies) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ImageContentSourcePolicyList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ImageContentSourcePolicyList{}
	err = c.client.Get().
		Resource("imagecontentsourcepolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested imageContentSourcePolicies.
func (c *imageContentSourcePolicies) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("imagecontentsourcepolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a imageContentSourcePolicy and creates it.  Returns the server's representation of the imageContentSourcePolicy, and an error, if there is any.
func (c *imageContentSourcePolicies) Create(ctx context.Context, imageContentSourcePolicy *v1alpha1.ImageContentSourcePolicy, opts v1.CreateOptions) (result *v1alpha1.ImageContentSourcePolicy, err error) {
	result = &v1alpha1.ImageContentSourcePolicy{}
	err = c.client.Post().
		Resource("imagecontentsourcepolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(imageContentSourcePolicy).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a imageContentSourcePolicy and updates it. Returns the server's representation of the imageContentSourcePolicy, and an error, if there is any.
func (c *imageContentSourcePolicies) Update(ctx context.Context, imageContentSourcePolicy *v1alpha1.ImageContentSourcePolicy, opts v1.UpdateOptions) (result *v1alpha1.ImageContentSourcePolicy, err error) {
	result = &v1alpha1.ImageContentSourcePolicy{}
	err = c.client.Put().
		Resource("imagecontentsourcepolicies").
		Name(imageContentSourcePolicy.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(imageContentSourcePolicy).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the imageContentSourcePolicy and deletes it. Returns an error if one occurs.
func (c *imageContentSourcePolicies) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("imagecontentsourcepolicies").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *imageContentSourcePolicies) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("imagecontentsourcepolicies").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched imageContentSourcePolicy.
func (c *imageContentSourcePolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ImageContentSourcePolicy, err error) {
	result = &v1alpha1.ImageContentSourcePolicy{}
	err = c.client.Patch(pt).
		Resource("imagecontentsourcepolicies").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
